#ifndef ZCONIO_H
#define ZCONIO_H
/*****************************************************************************
* ZCONIO.H                                                                   *
*                                                                            *
* (c) Copyright 1996, Zonn Moore.  All rights reserved.                      *
*****************************************************************************/

#ifndef ZSTDDEF.H
#include	"zstddef.h"
#endif

/* Flags used by 'ctos_()', 'itos_()' and 'ltos_()' */

#define		NTOS_SGN_F		0x04		// print number as signed
#define		NTOS_HEX_F		0x08		// print number in hex
#define		NTOS_BLZ_F		0x10		// blank leading zeros
#define		NTOS_DLZ_F		0x20		// delete leading (overides XBLZ_F)
#define		NTOS_COM_F		0x40		// print commas
#define		NTOS_NOT_F		0x80		// no terminating '\0' character

extern int	kgetch( void);
extern int	kgetchx( void);
extern int	kkbhit( void);
extern int	kkbhitx( void);
extern int	kwaitkey( char *);
extern uint	vgetcpos( uint scn);
extern uint	vsetctyp( uint scn, uint typ);
extern uint	vgetctyp( uint scn);
extern void	vsetcpos( uint scn, uint pos);
extern uint	vgetcreg( uint scn, uint typ);

#ifdef __cplusplus

extern int kgets(
	char	*bfr,
	uint	len,
	char	*vChrs = 0,
	char	*xChrs = 0,
	char	*oBfr = 0
);

extern "C" int			kflush( void);
extern "C" int			kgshft( void);
extern "C" t_logic	breakkey( t_logic);
extern "C" t_logic	breaktest( t_logic);
extern "C" void		vcls( void);
extern "C" void		vsetmode( uint mode);
extern "C" uint		vgetboard( void);
extern "C" uint		is6845( uint crtc);
extern "C" void		vstate( uint *, uint *, uint *, uint *);
extern "C" uint		vbtype( void);
extern "C" void		vsetcpos_( uint crtc, uint pos);
extern "C" uint		vgetcpos_( uint crtc);
extern "C" void		vsetctyp_( uint crtc, uint regs);
extern "C" char		*ctos( char *str, char cc, uint size, uint flgs);
extern "C" char		*itos( char *str, int ii, uint size, uint flgs);
extern "C" char		*ltos( char *str, long ll, uint size, uint flgs);
extern "C" ulong		endianFix32( ulong value);
extern "C" uint		endianFix16( uint value);
extern "C" void		far *paraAdj( void far *aParaAdj);

#if 0

/* Some reasons for C++ */

inline char *ntos( char *str, char cc, uint size, uint flgs)
{
	return (ctos( str, cc, size, flgs | NTOS_SGN_F));
}
	
inline char *ntos( char *str, schar cc, uint size, uint flgs)
{
	return (ctos( str, cc, size, flgs | NTOS_SGN_F));
}
	
inline char *ntos( char *str, uchar cc, uint size, uint flgs)
{
	return (ctos( str, cc, size, flgs & ~NTOS_SGN_F));
}
	
inline char *ntos( char *str, int ii, uint size, uint flgs)
{
	return (itos( str, ii, size, flgs | NTOS_SGN_F));
}
	
inline char *ntos( char *str, uint ii, uint size, uint flgs)
{
	return (itos( str, ii, size, flgs & ~NTOS_SGN_F));
}
	
inline char *ntos( char *str, long ll, uint size, uint flgs)
{
	return (ltos( str, ll, size, flgs | NTOS_SGN_F));
}
	
inline char *ntos( char *str, ulong ll, uint size, uint flgs)
{
	return (ltos( str, ll, size, flgs & ~NTOS_SGN_F));
}
#endif
	
#else
extern int		kflush( void);
extern int		kgshft( void);
extern int		breakkey( int);
extern int		breaktest( int);
extern void		vcls( void);
extern void		vsetmode( uint mode);
extern uint		vgetboard( void);
extern uint		is6845( uint crtc);
extern void		vstate( uint *, uint *, uint *, uint *);
extern uint		vbtype( void);
extern void		vsetcpos_( uint crtc, uint pos);
extern uint		vgetcpos_( uint crtc);
extern void		vsetctyp_( uint crtc, uint regs);
extern char		*ctos( char *str, char cc, uint size, uint flgs);
extern char		*itos( char *str, int ii, uint size, uint flgs);
extern char		*ltos( char *str, long ll, uint size, uint flgs);
extern ulong	endianFix32( ulong value);
extern uint		endianFix16( uint value);
extern void		far *paraAdj( void far *aParaAdj);

extern int kgets(
	char	*bfr,
	uint	len,
	char	*vChrs,
	char	*xChrs,
	char	*oBfr
);

#endif

#endif
